function PrimeUI:Code(data, sessionData)
    local valuebar = Turbine.UI.Control()
    valuebar:SetParent(self)

    valuebar.codeData = sessionData

    valuebar.Tools = {        
        AddCallback = AddCallback,
        RemoveCallback = RemoveCallback,
        Turbine = Turbine,
        pairs = pairs,
        math = math,
        Print = ChatOutput,
        string = string,
        FormatTimeString = FormatTimeString,
        tonumber = tonumber,
        PrintTable = PrintTable,
        Round = Round,
        pcall = pcall,

        -- Handlers
        Updater = Updater,
        ChatEventHandler = ChatEventHandler,
        PlayerEffectsHandler = PlayerEffectsHandler,
        GroupEffectsHandler = GroupEffectsHandler,
        EventWindows = EventWindows,
        PlayerHandlerObject = PlayerHandlerObject,
        ActionHandlerObject = ActionHandlerObject,
        SkillEventHandler = SkillEventHandler,
        StatEventHandling = StatEventHandling,
        Roles = Roles,
        TargetHandlerObject = TargetHandlerObject,
        rezTracker = rezTracker,
        LocationHandler = LocationHandler,
        NameHandlerObject = NameHandlerObject,
        EXPHandler = EXPHandler,
    }

    local result, func = pcall(loadstring, string.format("return function(PrimeUIObject, codeData, args, event) %s end", data.Code))

    if result and func then
        valuebar.func = func()
        setfenv(valuebar.func, valuebar.Tools)
    else
        ChatOutput(string.format("Failed to load code for %s", self.name))
    end

    valuebar.events = {}

    for keyword in string.gmatch(data["Triggers"], "([^,]+)") do
        valuebar.events[keyword] = true
    end

    if valuebar.func then
        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger",
        function(event)
            --PrintTable(self.codeData)
            if valuebar.events[event] then

                local success, result = pcall(valuebar.func, self, valuebar.codeData, self.args[event], event)

                if data.Debug_Mode and succes then
                    ChatOutput(string.format("Successfully exectued code for %s in UI %s", data.NickName or "Code Element", self.name))
                elseif not success then
                    ThrowException(string.format("Error in code for  %s in UI %s.\n\n", data.NickName or "Code Element", self.name, result))
                    if data.Debug_Mode then
                        ThrowException(Turbine.Engine.GetCallStack())
                    end
                end
            end
        end))
    end

    table.insert(self.UI, valuebar)
end