function PrimeUI:TimerIconGroupWindow(data, parent)
    local valuebar = TimerIconGroupWindow(data, parent)
    self.lookup[data.NickName or ""] = valuebar
    local x = self:ContentAlignement(data["Alignment"], (data["Width"]))
    local y = self.currentHeight
    if self.groupMode then
        x = data["X"]
        y = data["Y"]
    end

    valuebar.nameFunction = function(text, name, args)
        return ReplaceTokens(string.gsub(text or "", "<name>", NameHandlerObject:GetName(name, true, "PrimeUITimerIconGroup", "") or ""), args or {})
    end

    if Tablelength(data.Timer_Icon_Triggers) > 0 then
        if data.Static then
            for key, value in pairs(data.Timer_Icon_Triggers) do
                local layoutTable = {
                    Scale = 1,
                    BorderSize = data.BorderSize or 0,
                    Normal_Opacity  = data.Opacity,
                    Always_Visible = false,
                    Icon = value.Icon,
                    Time = value.Time == true and self.args[event] and self.args[event]["Duration"] or value.Time or 0,
                
                    Timer_Font = Turbine.UI.Lotro.Font[data.Timer_Font],
                    Text_Font = Turbine.UI.Lotro.Font[data.Text_Font],
                    Timer_Font_Colour = self:ColourTupleToTurbineColour(data.Timer_Font_Colour),
                    Text_Font_Colour = self:ColourTupleToTurbineColour(data.Text_Font_Colour),
                
                    Border_Colour = self:ColourTupleToTurbineColour(data.BorderColour),
                    Shadow_timer = data.Shadow_timer,
                    Increasing_Shadow = data.Increasing_Shadow,
                
                    Timer_Alignment = Turbine.UI.ContentAlignment[data.Timer_Alignment],
                    Text_Alignment = Turbine.UI.ContentAlignment[data.Text_Alignment],
            
                    Invisible_While_Timer_Active = value.Invisible_While_Active,
                    Invisible_While_Timer_Inactive = value.Invisible_While_Not_Active,
            
                    Show_Duration = data.Show_Duration,
                    Text = valuebar.nameFunction(value.Text, self.player:GetName(), self.args[event] or {}),
            
                    Variable_Name = value.Variable_Name,

                    Timer_Sorting = data.Timer_Sorting,

                    Sort_Order = value.Sort_Order or 0,
            
                    Alignment = data["Alignment"],
                    UIWidth = self.width,
                    X = data.X,
                    Y = data.Y,
                    Width = data.Width,
                    Height = data.Height,
                    Advanced = self.groupMode,
                }
                valuebar:StartIcon(key, layoutTable, true)
            end
        end

        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger", 
        function(event)
            local value = data["Timer_Icon_Triggers"][event]
            if value then
                local layoutTable = {
                    Scale = 1,
                    BorderSize = data.BorderSize or 0,
                    Normal_Opacity  = data.Opacity,
                    Always_Visible = false,
                    Icon = value.Icon,
                    Time = value.Time == true and self.args[event] and self.args[event]["Duration"] or value.Time or 0,
                
                    Timer_Font = Turbine.UI.Lotro.Font[data.Timer_Font],
                    Text_Font = Turbine.UI.Lotro.Font[data.Text_Font],
                    Timer_Font_Colour = self:ColourTupleToTurbineColour(data.Timer_Font_Colour),
                    Text_Font_Colour = self:ColourTupleToTurbineColour(data.Text_Font_Colour),
                
                    Border_Colour = self:ColourTupleToTurbineColour(data.BorderColour),
                    Shadow_timer = data.Shadow_timer,
                    Increasing_Shadow = data.Increasing_Shadow,
                
                    Timer_Alignment = Turbine.UI.ContentAlignment[data.Timer_Alignment],
                    Text_Alignment = Turbine.UI.ContentAlignment[data.Text_Alignment],
            
                    Invisible_While_Timer_Active = value.Invisible_While_Active,
                    Invisible_While_Timer_Inactive = value.Invisible_While_Not_Active,
            
                    Show_Duration = data.Show_Duration,
                    Text = valuebar.nameFunction(value.Text, self.player:GetName(), self.args[event] or {}),
            
                    Variable_Name = value.Variable_Name,

                    Timer_Sorting = data.Timer_Sorting,

                    Sort_Order = value.Sort_Order or 0,
            
                    Alignment = data["Alignment"],
                    UIWidth = self.width,
                    X = data.X,
                    Y = data.Y,
                    Width = data.Icon_Width,
                    Height = data.Icon_Height,
                    Advanced = self.groupMode,
                }
                if data.Static then
                    valuebar:StartStaticIcon(event, layoutTable)
                else
                    valuebar:StartIcon(event, layoutTable, false)
                end
                
            end
        end))
    end

    self.lookup[data.NickName or ""] = valuebar

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
    self.heightSize = self.heightSize + data["Height"] + 2 * data["BorderSize"]
    
    table.insert(self.tools, valuebar)
end