CheckedDropdownControl = class(Turbine.UI.Control)
function CheckedDropdownControl:Constructor(parent, width, y, args)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetMouseVisible(false)
    self:SetPosition(0, y)
    self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

    self.width = width

    self.itemTable = {}

    self.dropdownBackground = Turbine.UI.Control()
    self.dropdownBackground:SetParent(self)
    self.dropdownBackground:SetSize(200, 20)
    self.dropdownBackground:SetPosition(5, 0)
    self.dropdownBackground:SetBackColor(Turbine.UI.Color.Black)

	self.dropdownSelectedBackgroundInner = Turbine.UI.Control()
	self.dropdownSelectedBackgroundInner:SetParent(self.dropdownBackground)
	self.dropdownSelectedBackgroundInner:SetSize(self.dropdownBackground:GetWidth() - 4 , self.dropdownBackground:GetHeight() - 4)
	self.dropdownSelectedBackgroundInner:SetPosition(2, 2)
	self.dropdownSelectedBackgroundInner:SetBackColor(Turbine.UI.Color.Gray)
	self.dropdownSelectedBackgroundInner:SetMouseVisible(true)


	self.dropdownSelectedItemLabel = Turbine.UI.Label()
	self.dropdownSelectedItemLabel:SetParent(self.dropdownSelectedBackgroundInner)
	self.dropdownSelectedItemLabel:SetSize(self.dropdownSelectedBackgroundInner:GetWidth() - 15, self.dropdownSelectedBackgroundInner:GetHeight())
	self.dropdownSelectedItemLabel:SetForeColor(Turbine.UI.Color(230/255, 200/255, 130/255))
	self.dropdownSelectedItemLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.dropdownSelectedItemLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.dropdownSelectedItemLabel:SetMultiline(false)
	self.dropdownSelectedItemLabel:SetMouseVisible(false)
	self.dropdownSelectedItemLabel:SetText(args.Text)

    self.dropdownArrow = Turbine.UI.Control()
	self.dropdownArrow:SetParent(self.dropdownSelectedBackgroundInner)
	self.dropdownArrow:SetSize(14, 14)
	self.dropdownArrow:SetPosition(self.dropdownSelectedBackgroundInner:GetWidth() - 15, 0)
	self.dropdownArrow:SetBackground(0x41007e1b)
	self.dropdownArrow:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.dropdownArrow:SetMouseVisible(false)

    self.dropdownSelectedBackgroundInner.MouseEnter = function()
        self.dropdownArrow:SetBackground(0x41007e18)
        self.dropdownSelectedItemLabel:SetForeColor(Turbine.UI.Color(240/255, 220/255, 150/255))
    end

    self.dropdownSelectedBackgroundInner.MouseLeave = function()
        self.dropdownArrow:SetBackground(0x41007e1b)
        self.dropdownSelectedItemLabel:SetForeColor(Turbine.UI.Color(230/255, 200/255, 130/255))
    end

    self.dropdownListBoxWindow = Turbine.UI.Window()
    self.dropdownListBoxWindow:SetSize(200, 200)
    self.dropdownListBoxWindow:SetBackColor(Turbine.UI.Color.Black)
    self.dropdownListBoxWindow:SetVisible(false)

    self.dropdownSelectedBackgroundInner.MouseClick = function()
        local one, two = self:PointToScreen(0, self.dropdownBackground:GetHeight())
        --self.dropdownListBoxWindow:SetPosition(self:PointToClient(0, self.dropdownBackground:GetHeight()))
        self.dropdownListBoxWindow:SetPosition(one + 5, two)
        self.dropdownListBoxWindow:SetVisible(not self.dropdownListBoxWindow:IsVisible())
        self.dropdownListBoxWindow:SetZOrder(99)
        self.dropdownListBoxWindow:Focus()
    end


    self.dropdownListBox = Turbine.UI.ListBox()
    self.dropdownListBox:SetParent(self.dropdownListBoxWindow)
    self.dropdownListBox:SetSize(self.dropdownListBoxWindow:GetWidth() - 4 - 10, self.dropdownListBoxWindow:GetHeight() - 4)
    self.dropdownListBox:SetPosition(2, 2)
    self.dropdownListBox:SetBackColor(Turbine.UI.Color.Gray)
    self.dropdownListBox:SetVisible(true)

    self.dropdownScrollbarBackground = Turbine.UI.Control()
    self.dropdownScrollbarBackground:SetParent(self.dropdownListBoxWindow)
    self.dropdownScrollbarBackground:SetSize(10, self.dropdownListBoxWindow:GetHeight() - 4)
    self.dropdownScrollbarBackground:SetPosition(self.dropdownListBoxWindow:GetWidth() - 2 - 10, 2)
    self.dropdownScrollbarBackground:SetBackColor(Turbine.UI.Color.Gray)
    self.dropdownScrollbarBackground:SetVisible(true)

    self.dropdownScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.dropdownScrollbar:SetParent(self.dropdownListBoxWindow)
    self.dropdownScrollbar:SetSize(10, self.dropdownListBoxWindow:GetHeight() - 4)
    self.dropdownScrollbar:SetPosition(self.dropdownListBoxWindow:GetWidth() - 2 - 10, 2)
    self.dropdownScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.dropdownScrollbar:SetBackColor(Turbine.UI.Color.Gray)
    self.dropdownScrollbar:SetVisible(true)
    self.dropdownListBox:SetVerticalScrollBar(self.dropdownScrollbar)

    --local sortedKeys2 = {}
    --for key, value in pairs(args.Items) do table.insert( sortedKeys2, value ) end
    --table.sort( sortedKeys2 )
    
    for name, value in spairs(args.Items, function(t, a, b) return a < b end) do
        local itemLabel = Turbine.UI.Lotro.CheckBox()
        itemLabel:SetText(name)
        itemLabel:SetSize(200 - 4, 20)
        itemLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        itemLabel:SetChecked(value)

        itemLabel.MouseEnter = function()
            --itemLabel:SetForeColor(Turbine.UI.Color.Black)
            itemLabel:SetForeColor(Turbine.UI.Color(230/255, 200/255, 130/255))
        end

        itemLabel.MouseLeave = function()
            itemLabel:SetForeColor(Turbine.UI.Color.White)
        end

        itemLabel.MouseClick = function()
            self.class = name
            --self.dropdownSelectedItemLabel:SetText(name)
            self.dropdownListBoxWindow:SetVisible(false)
            self:ValueChanged()
        end

        self.itemTable[name] = itemLabel

        self.dropdownListBox:AddItem(itemLabel)
    end

    self:Format()
end

function CheckedDropdownControl:ValueChanged()

end

function CheckedDropdownControl:Format()
    self:SetSize(self.width, 20)
    --self.dropdownSelectedItemLabel:SetSize(self.width * .3, 20)
    self.dropdownListBoxWindow:SetSize(200, math.min(20 * self.dropdownListBox:GetItemCount(), 200))
    self.dropdownListBox:SetSize(self.dropdownListBoxWindow:GetWidth() - 4 - 10, self.dropdownListBoxWindow:GetHeight() - 4)
    self.dropdownScrollbarBackground:SetSize(10, self.dropdownListBoxWindow:GetHeight() - 4)
    self.dropdownScrollbar:SetSize(10, self.dropdownListBoxWindow:GetHeight() - 4)
end

function CheckedDropdownControl:SetItemValueWithoutTrigger(itemName, value)
    if self.itemTable[itemName] then
        self.itemTable[itemName]:SetChecked(value)
    end
end

function CheckedDropdownControl:GetValue()
    return tostring(self.dropdownSelectedItemLabel:GetText())
end

function CheckedDropdownControl:SetValue(value)
    self.dropdownSelectedItemLabel:SetText(tostring(value))
end

function CheckedDropdownControl:Unload()
    self.itemTable = nil
    self.dropdownListBoxWindow:SetParent(nil)
    self:SetParent(nil)
end